// tutorial - le triple buffering (A,B,C)
//  C s'applique sur B puis B s'applique sur A
// permet de placer une image sur un fond en rendant transparent le fond de l'image
// et de faire scroller une image dans le fond de l'image en premant en compte que
// certaines zones (de couleur)

// Auteur  : Lionel ROUVAREL  lionel27@club-internet.fr
// Site de l'auteur : LIOCITY   http://perso.club-internet.fr/lionel27

unit logosUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Timer1: TTimer;
    Label1: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
   private
    { Dclarations prives }
   public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  fond_calcul:Tbitmap;
  fond_base:tbitmap;
  titre,fond_titre,calcul_titre,fond_plus:tbitmap;
  i,k,m:integer;

implementation
// Cette unit permet de charger des images JPEG dans des TImages
// si ca plante  la compilation, il faut aller sur le Site de Michel Bardou
// qui est sur ma page Delphi(liens) et qui explique comment faire...
// Sinon remplacer les image3 et image4 par des images de type BMP et enlevez la ligne "USES Jpeg;"
uses jpeg;
{$R *.DFM}

procedure libere;
begin
  form1.timer1.enabled:=false;
  fond_calcul.free;
  fond_plus.free;
  titre.free;
  fond_titre.free;
  calcul_titre.free;
  fond_base.free;
  halt;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  libere;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var j,e:integer;
    vitesse:byte;
    rec:trect;
begin
  vitesse:=2;
  for j:=1 to 3 do  // Truc pour acclrer : cette boucle permet de faire plusieurs fois le deplacement
  begin
    inc(i);if i>50 then i:=0;
    inc(k,vitesse); if k>375 then k:=1;

    //decalage de l'image de fond pour la faire scroller vers la gauche
    calcul_titre.canvas.draw(-k,0,fond_plus);
    calcul_titre.Width:=375;
    calcul_titre.Canvas.draw(0,0,titre);

    // annuler les parties en dehors du logo
    fond_calcul.canvas.draw(200,10,calcul_titre);
    rec.left:=200+25;
    rec.Top:=10+25;
    rec.Right:=rec.left+calcul_titre.width-45;
    rec.Bottom:=calcul_titre.height;
    canvas.CopyRect(rec,fond_calcul.canvas,rec);

    // affichage d'un message
    inc(m,2); if m>300 then m:=-100;
    canvas.TextOut(m,150,' Appuyez sur une touche...');
  end;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
  // preparation des 2 buffers de travail
  fond_titre:=tbitmap.create;
  calcul_titre:=tbitmap.create;
  fond_base:=tbitmap.create;
  // chargement des images

  // l'image de fond est INDISPENSABLE pour effectuer les operations logiques
  // qui dterminent la transparence d'une couleur
  fond_base.assign(image5.picture.graphic);  // l'image de fond
  fond_titre.assign(image4.Picture.graphic); // image qui va scroller vers la gauche

  // preparation de l'image de fond du logo doublee en largueur
  // pour simplifier, l'image qui scrolle est recopier 2 fois  la suite
  fond_plus:=tbitmap.create;
  fond_plus.Width:=fond_titre.width*2;
  fond_plus.Height:=fond_titre.Height;
  fond_plus.canvas.draw(0,0,image4.Picture.graphic);
  fond_plus.canvas.draw(375,0,image4.Picture.graphic);

  fond_calcul:=tbitmap.create;
  fond_calcul.assign(fond_base);

  titre:=tbitmap.create; // creation et chargement du titre LOGOS
  titre.assign(image3.Picture.graphic);
  titre.transparent:=true;
  // le point(100,100) = la couleur qui sera transparente sur l'image Titre (LOGOS)
  titre.TransparentColor:=titre.canvas.pixels[100,100];

  calcul_titre.assign(fond_titre);
  calcul_titre.Canvas.draw(0,0,titre);
  calcul_titre.transparent:=true; // active la transparance par defaut (point le plus en bas  gauche)
end;


procedure TForm1.FormPaint(Sender: TObject);
begin
  canvas.draw(0,0,fond_calcul);
  calcul_titre.width:=375;
  // pour accelerer l'affichage, la zone qui est raffiche correspond
  // juste  la taille du logo LOGOS moins l'paisseur des bords
  canvas.draw(200,10,calcul_titre);
end;

end.
